<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [bullmq](./bullmq.md) &gt; [JobsOptions](./bullmq.jobsoptions.md)

## JobsOptions interface

<b>Signature:</b>

```typescript
export interface JobsOptions 
```

## Properties

|  Property | Type | Description |
|  --- | --- | --- |
|  [attempts?](./bullmq.jobsoptions.attempts.md) | number | <i>(Optional)</i> The total number of attempts to try the job until it completes. |
|  [backoff?](./bullmq.jobsoptions.backoff.md) | number \| [BackoffOptions](./bullmq.backoffoptions.md) | <i>(Optional)</i> Backoff setting for automatic retries if the job fails |
|  [delay?](./bullmq.jobsoptions.delay.md) | number | <i>(Optional)</i> An amount of milliseconds to wait until this job can be processed. Note that for accurate delays, worker and producers should have their clocks synchronized. |
|  [jobId?](./bullmq.jobsoptions.jobid.md) | string | <i>(Optional)</i> Override the job ID - by default, the job ID is a unique integer, but you can use this setting to override it. If you use this option, it is up to you to ensure the jobId is unique. If you attempt to add a job with an id that already exists, it will not be added. |
|  [lifo?](./bullmq.jobsoptions.lifo.md) | boolean | <i>(Optional)</i> If true, adds the job to the right of the queue instead of the left (default false) |
|  [parent?](./bullmq.jobsoptions.parent.md) | { id: string; queue: string; } | <i>(Optional)</i> |
|  [prevMillis?](./bullmq.jobsoptions.prevmillis.md) | number | <i>(Optional)</i> Internal property used by repeatable jobs. |
|  [priority?](./bullmq.jobsoptions.priority.md) | number | <i>(Optional)</i> Ranges from 1 (highest priority) to MAX\_INT (lowest priority). Note that using priorities has a slight impact on performance, so do not use it if not required. |
|  [rateLimiterKey?](./bullmq.jobsoptions.ratelimiterkey.md) | string | <i>(Optional)</i> Rate limiter key to use if rate limiter enabled. |
|  [removeOnComplete?](./bullmq.jobsoptions.removeoncomplete.md) | boolean \| number \| [KeepJobs](./bullmq.keepjobs.md) | <i>(Optional)</i> If true, removes the job when it successfully completes When given an number, it specifies the maximum amount of jobs to keep, or you can provide an object specifying max age and/or count to keep. Default behavior is to keep the job in the completed set. |
|  [removeOnFail?](./bullmq.jobsoptions.removeonfail.md) | boolean \| number \| [KeepJobs](./bullmq.keepjobs.md) | <i>(Optional)</i> If true, removes the job when it fails after all attempts. When given an number, it specifies the maximum amount of jobs to keep, or you can provide an object specifying max age and/or count to keep. |
|  [repeat?](./bullmq.jobsoptions.repeat.md) | [RepeatOptions](./bullmq.repeatoptions.md) | <i>(Optional)</i> Repeat this job, for example based on a <code>cron</code> schedule. |
|  [sizeLimit?](./bullmq.jobsoptions.sizelimit.md) | number | <i>(Optional)</i> Limits the size in bytes of the job's data payload (as a JSON serialized string). |
|  [stackTraceLimit?](./bullmq.jobsoptions.stacktracelimit.md) | number | <i>(Optional)</i> Limits the amount of stack trace lines that will be recorded in the stacktrace. |
|  [timeout?](./bullmq.jobsoptions.timeout.md) | number | <i>(Optional)</i> The number of milliseconds after which the job should be fail with a timeout error. |
|  [timestamp?](./bullmq.jobsoptions.timestamp.md) | number | <i>(Optional)</i> Timestamp when the job was created. Defaults to <code>Date.now()</code>. |

